"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.EntityUtil = void 0;
var tstl_1 = require("tstl");
var ranges_1 = require("tstl/ranges");
var findRepository_1 = require("../functional/findRepository");
/**
 * Utility functions for ORM Entities.
 *
 * @author Jeongho Nam - https://github.com/samchon
 */
var EntityUtil;
(function (EntityUtil) {
    /**
     * Get table name.
     *
     * @param entity Target entity type
     * @returns Table name
     */
    function name(entity) {
        return (0, findRepository_1.findRepository)(entity).metadata.tableName;
    }
    EntityUtil.name = name;
    /**
     * Get table info.
     *
     * @param entity Target entity type
     * @returns Table info
     */
    function info(entity) {
        var dict = table_infos_.get((0, findRepository_1.findRepository)(entity).manager.connection);
        return dict.get(name(entity));
    }
    EntityUtil.info = info;
    var table_infos_ = new tstl_1.VariadicSingleton(function (connection) {
        var e_1, _a, e_2, _b, e_3, _c;
        var dict = new Map();
        try {
            for (var _d = __values(connection.entityMetadatas), _e = _d.next(); !_e.done; _e = _d.next()) {
                var entity = _e.value;
                var info_1 = {
                    target: entity.target,
                    schema: entity.schema,
                    name: entity.tableName,
                    primary: entity.primaryColumns[0].databaseName,
                    uniques: entity.uniques.map(function (u) {
                        return u.columns.map(function (c) { return c.databaseName; });
                    }),
                    children: [],
                };
                dict.set(info_1.name, info_1);
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_e && !_e.done && (_a = _d.return)) _a.call(_d);
            }
            finally { if (e_1) throw e_1.error; }
        }
        try {
            for (var _f = __values(connection.entityMetadatas), _g = _f.next(); !_g.done; _g = _f.next()) {
                var entity = _g.value;
                var info_2 = dict.get(entity.tableName);
                var parentTuples = entity.foreignKeys.map(function (fk) { return [
                    dict.get(fk.referencedEntityMetadata.tableName),
                    fk.columns[0].databaseName,
                ]; });
                try {
                    for (var parentTuples_1 = (e_3 = void 0, __values(parentTuples)), parentTuples_1_1 = parentTuples_1.next(); !parentTuples_1_1.done; parentTuples_1_1 = parentTuples_1.next()) {
                        var _h = __read(parentTuples_1_1.value, 2), parent_1 = _h[0], foreign = _h[1];
                        parent_1.children.push({ info: info_2, foreign: foreign });
                    }
                }
                catch (e_3_1) { e_3 = { error: e_3_1 }; }
                finally {
                    try {
                        if (parentTuples_1_1 && !parentTuples_1_1.done && (_c = parentTuples_1.return)) _c.call(parentTuples_1);
                    }
                    finally { if (e_3) throw e_3.error; }
                }
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (_g && !_g.done && (_b = _f.return)) _b.call(_f);
            }
            finally { if (e_2) throw e_2.error; }
        }
        return dict;
    });
    /* -----------------------------------------------------------
        UNIFIER
    ----------------------------------------------------------- */
    /**
     * Merge duplicate records into one.
     *
     * Absords and merges multiple entity records (*duplicates*) into one (*original*).
     * That is, all records listed in *duplicates* would be erased, and instead,
     * references to entities of all records subordinate to duplicate records would be
     * replaced with original ones.
     *
     * During unification, if there're some children entities dependent on `Entity` and
     * their foreign columns referencing `Entity` are belonged to unique constraint,
     * they would be unified recursively.
     *
     * @template Entity Target entity type
     * @param original Original record to absorb
     * @param duplicates Duplicated records to be absorbed
     */
    function unify(original, duplicates) {
        return __awaiter(this, void 0, void 0, function () {
            var meta_1, deprecates, exp_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 3, , 4]);
                        return [4 /*yield*/, info(original.constructor)];
                    case 1:
                        meta_1 = _a.sent();
                        deprecates = duplicates.map(function (elem) { return elem[meta_1.primary]; });
                        return [4 /*yield*/, _Unify(meta_1, original[meta_1.primary], deprecates)];
                    case 2:
                        _a.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        exp_1 = _a.sent();
                        console.log(exp_1);
                        process.exit(-1);
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/];
                }
            });
        });
    }
    EntityUtil.unify = unify;
    function _Unify(table, keep, deprecates) {
        return __awaiter(this, void 0, void 0, function () {
            var _loop_1, _a, _b, dependency, e_4_1;
            var e_4, _c;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        if (deprecates.length === 0)
                            return [2 /*return*/];
                        _loop_1 = function (dependency) {
                            var unique, _e, _f, columns, e_5_1;
                            var e_5, _g, _h;
                            return __generator(this, function (_j) {
                                switch (_j.label) {
                                    case 0:
                                        unique = [];
                                        if (!(dependency.info.uniques.length !== 0)) return [3 /*break*/, 8];
                                        _j.label = 1;
                                    case 1:
                                        _j.trys.push([1, 6, 7, 8]);
                                        _e = (e_5 = void 0, __values(dependency.info.uniques)), _f = _e.next();
                                        _j.label = 2;
                                    case 2:
                                        if (!!_f.done) return [3 /*break*/, 5];
                                        columns = _f.value;
                                        if (!(columns.find(function (col) { return col === dependency.foreign; }) !==
                                            undefined)) return [3 /*break*/, 4];
                                        unique.push(false);
                                        return [4 /*yield*/, _Unify_unique_children(keep, deprecates, dependency, columns)];
                                    case 3:
                                        _j.sent();
                                        _j.label = 4;
                                    case 4:
                                        _f = _e.next();
                                        return [3 /*break*/, 2];
                                    case 5: return [3 /*break*/, 8];
                                    case 6:
                                        e_5_1 = _j.sent();
                                        e_5 = { error: e_5_1 };
                                        return [3 /*break*/, 8];
                                    case 7:
                                        try {
                                            if (_f && !_f.done && (_g = _e.return)) _g.call(_e);
                                        }
                                        finally { if (e_5) throw e_5.error; }
                                        return [7 /*endfinally*/];
                                    case 8:
                                        if (!(unique.length === 0)) return [3 /*break*/, 10];
                                        // UPDATE RECORD DIRECTLY
                                        return [4 /*yield*/, (0, findRepository_1.findRepository)(dependency.info.target)
                                                .createQueryBuilder()
                                                .andWhere("".concat(dependency.foreign, " IN (:...deprecates)"), {
                                                deprecates: deprecates,
                                            })
                                                .update((_h = {}, _h[dependency.foreign] = keep, _h))
                                                .updateEntity(false)
                                                .execute()];
                                    case 9:
                                        // UPDATE RECORD DIRECTLY
                                        _j.sent();
                                        _j.label = 10;
                                    case 10: return [2 /*return*/];
                                }
                            });
                        };
                        _d.label = 1;
                    case 1:
                        _d.trys.push([1, 6, 7, 8]);
                        _a = __values(table.children), _b = _a.next();
                        _d.label = 2;
                    case 2:
                        if (!!_b.done) return [3 /*break*/, 5];
                        dependency = _b.value;
                        return [5 /*yield**/, _loop_1(dependency)];
                    case 3:
                        _d.sent();
                        _d.label = 4;
                    case 4:
                        _b = _a.next();
                        return [3 /*break*/, 2];
                    case 5: return [3 /*break*/, 8];
                    case 6:
                        e_4_1 = _d.sent();
                        e_4 = { error: e_4_1 };
                        return [3 /*break*/, 8];
                    case 7:
                        try {
                            if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
                        }
                        finally { if (e_4) throw e_4.error; }
                        return [7 /*endfinally*/];
                    case 8: 
                    // DELETE THE DUPLICATED RECORDS
                    return [4 /*yield*/, (0, findRepository_1.findRepository)(table.target)
                            .createQueryBuilder()
                            .andWhere("".concat(table.primary, " IN (:...deprecates)"), { deprecates: deprecates })
                            .delete()
                            .execute()];
                    case 9:
                        // DELETE THE DUPLICATED RECORDS
                        _d.sent();
                        return [2 /*return*/];
                }
            });
        });
    }
    function _Unify_unique_children(keep, deprecates, child, columns) {
        return __awaiter(this, void 0, void 0, function () {
            var group, sql, recordList, dict, _loop_2, recordList_1, recordList_1_1, record, _loop_3, dict_1, dict_1_1, it, e_6_1;
            var e_7, _a, e_6, _b;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        group = columns.filter(function (col) { return col !== child.foreign; });
                        if (!(group.length !== 0)) return [3 /*break*/, 2];
                        sql = "\n                UPDATE ".concat(child.info.schema, ".").concat(child.info.name, "\n                SET ").concat(child.foreign, " = $1\n                WHERE ").concat(child.info.primary, " IN\n                (\n                    SELECT CAST(MIN(CAST(").concat(child.info.primary, " AS VARCHAR(36))) AS UUID) AS ").concat(child.info.primary, "\n                    FROM ").concat(child.info.schema, ".").concat(child.info.name, "\n                    WHERE ").concat(child.foreign, " IN ($1, ").concat(deprecates
                            .map(function (_, index) { return "$".concat(index + 2); })
                            .join(", "), ")\n                    GROUP BY ").concat(group.join(", "), "\n                    HAVING COUNT(CASE WHEN ").concat(child.foreign, " = $1 THEN 1 ELSE NULL END) = 0\n                )");
                        return [4 /*yield*/, (0, findRepository_1.findRepository)(child.info.target).query(sql, __spreadArray([
                                keep
                            ], __read(deprecates), false))];
                    case 1:
                        _c.sent();
                        _c.label = 2;
                    case 2: return [4 /*yield*/, (0, findRepository_1.findRepository)(child.info.target).query("SELECT * \n            FROM ".concat(child.info.schema, ".").concat(child.info.name, " \n            WHERE ").concat(child.foreign, " IN (").concat(__spreadArray([keep], __read(deprecates), false).map(function (_, index) { return "$".concat(index + 1); })
                            .join(", "), ")\n            ORDER BY ").concat(child.info.primary, " ASC"), __spreadArray([keep], __read(deprecates), false))];
                    case 3:
                        recordList = _c.sent();
                        dict = new tstl_1.HashMap(function (elements) { return tstl_1.hash.apply(void 0, __spreadArray([], __read(elements), false)); }, function (x, y) { return (0, ranges_1.equal)(x, y); });
                        _loop_2 = function (record) {
                            var key = group.map(function (col) { return record[col]; });
                            var array = dict.take(key, function () { return []; });
                            array.push(record);
                        };
                        try {
                            for (recordList_1 = __values(recordList), recordList_1_1 = recordList_1.next(); !recordList_1_1.done; recordList_1_1 = recordList_1.next()) {
                                record = recordList_1_1.value;
                                _loop_2(record);
                            }
                        }
                        catch (e_7_1) { e_7 = { error: e_7_1 }; }
                        finally {
                            try {
                                if (recordList_1_1 && !recordList_1_1.done && (_a = recordList_1.return)) _a.call(recordList_1);
                            }
                            finally { if (e_7) throw e_7.error; }
                        }
                        _loop_3 = function (it) {
                            var index, master, slaves;
                            return __generator(this, function (_d) {
                                switch (_d.label) {
                                    case 0:
                                        index = it.second.findIndex(function (rec) { return rec[child.foreign] === keep; });
                                        master = it.second[index];
                                        slaves = it.second.filter(function (_, i) { return i !== index; });
                                        return [4 /*yield*/, _Unify(child.info, master[child.info.primary], slaves.map(function (s) { return s[child.info.primary]; }))];
                                    case 1:
                                        _d.sent();
                                        return [2 /*return*/];
                                }
                            });
                        };
                        _c.label = 4;
                    case 4:
                        _c.trys.push([4, 9, 10, 11]);
                        dict_1 = __values(dict), dict_1_1 = dict_1.next();
                        _c.label = 5;
                    case 5:
                        if (!!dict_1_1.done) return [3 /*break*/, 8];
                        it = dict_1_1.value;
                        return [5 /*yield**/, _loop_3(it)];
                    case 6:
                        _c.sent();
                        _c.label = 7;
                    case 7:
                        dict_1_1 = dict_1.next();
                        return [3 /*break*/, 5];
                    case 8: return [3 /*break*/, 11];
                    case 9:
                        e_6_1 = _c.sent();
                        e_6 = { error: e_6_1 };
                        return [3 /*break*/, 11];
                    case 10:
                        try {
                            if (dict_1_1 && !dict_1_1.done && (_b = dict_1.return)) _b.call(dict_1);
                        }
                        finally { if (e_6) throw e_6.error; }
                        return [7 /*endfinally*/];
                    case 11: return [2 /*return*/];
                }
            });
        });
    }
})(EntityUtil = exports.EntityUtil || (exports.EntityUtil = {}));
//# sourceMappingURL=EntityUtil.js.map